module flash
 #(	parameter	flash_file = "main.mem",
	parameter	flash_width = 11
 )
 (	input				clk,
	input				mem_ce,
	input				mem_we,
	input	[flash_width-1:0]	mem_a,
	input 	[3:0]			mem_mask,
	output	[31:0]			mem_d,
	input	[31:0]			mem_w_data
 );

reg [31:0] flash_array [0:2**flash_width-1];

reg [31:0] data_read;

assign mem_d = data_read;

always @(posedge clk) begin
	if (mem_ce) begin
		data_read <= flash_array[mem_a];
        end else begin
                if (mem_we && mem_mask[0]) flash_array[mem_a][7:0]   <= mem_w_data[7:0];
                if (mem_we && mem_mask[1]) flash_array[mem_a][15:8]  <= mem_w_data[15:8];
                if (mem_we && mem_mask[2]) flash_array[mem_a][23:16] <= mem_w_data[23:16];
                if (mem_we && mem_mask[3]) flash_array[mem_a][31:24] <= mem_w_data[31:24];
        end

end

initial begin
	`include "dummy_flash.v"
end

endmodule
