`timescale 100ns/10ns

`ifdef SIMULATOR
module dump;
//reg testbit = 0;
initial begin
        $dumpfile("top.vcd");
//      $dumpvars(1,testbit);
end
endmodule
`endif

`include "flash.v"

/*****************************************************************************/

module top
 (      input   hwclk,
	output  [7:0] led,

        input   ftdi_rx,
        output  ftdi_tx,
 );

parameter	pmem_width = 11;	/* 8 kilobytes == 2 kilowords */

assign		ftdi_tx = ftdi_rx; 

wire            clk;
assign		clk = hwclk;

wire 		[7:0] led;

flash	 core0_flash ( clk, pmem_ce, 1'b0, pmem_a[pmem_width+1:2], 4'b0, pmem_d, 32'b0 );
defparam core0_flash.flash_width = pmem_width;

wire		pmem_ce = 1;
reg [31:0]	pmem_a = 1;
wire [31:0]	pmem_d;

assign	led = pmem_d[31:24] ^ pmem_d[23:16] ^ pmem_d[15:8] ^ pmem_d[7:0];

always @(posedge clk) begin
        pmem_a <= (pmem_a[0] ? 32'hEDB88320 : 0) ^ (pmem_a>>1);
end

endmodule

